    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Interface java.sql.Statement

public interface Statement

A Statement object is used for executing a static SQL statement and obtaining the results produced by it.

Only one ResultSet per Statement can be open at any point in time. Therefore, if the reading of one ResultSet is interleaved with the reading of another, each must have been generated by different Statements. All statement execute methods implicitly close a statment's current ResultSet if an open one exists.

See Also:
  createStatement, ResultSet

##

cancel()
  Cancel can be used by one thread to cancel a statement that is being executed by another thread.
clearWarnings()
  After this call, getWarnings returns null until a new warning is reported for this Statement.
close()
  In many cases, it is desirable to immediately release a Statements's database and JDBC resources instead of waiting for this to happen when it is automatically closed; the close method provides this immediate release.
execute(String)
  Execute a SQL statement that may return multiple results.
executeQuery(String)
  Execute a SQL statement that returns a single ResultSet.
executeUpdate(String)
  Execute a SQL INSERT, UPDATE or DELETE statement.
getMaxFieldSize()
  The maxFieldSize limit (in bytes) is the maximum amount of data returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR columns.
getMaxRows()
  The maxRows limit is the maximum number of rows that a ResultSet can contain.
getMoreResults()
  getMoreResults moves to a Statement's next result.
getQueryTimeout()
  The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute.
getResultSet()
  getResultSet returns the current result as a ResultSet.
getUpdateCount()
  getUpdateCount returns the current result as an update count; if the result is a ResultSet or there are no more results, -1 is returned.
getWarnings()
  The first warning reported by calls on this Statement is returned.
setCursorName(String)
  setCursorname defines the SQL cursor name that will be used by subsequent Statement execute methods.
setEscapeProcessing(boolean)
  If escape scanning is on (the default), the driver will do escape substitution before sending the SQL to the database.
setMaxFieldSize(int)
  The maxFieldSize limit (in bytes) is set to limit the size of data that can be returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR fields.
setMaxRows(int)
  The maxRows limit is set to limit the number of rows that any ResultSet can contain.
setQueryTimeout(int)
  The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute.

##

executeQuery

     public abstract ResultSet executeQuery(String sql) throws SQLException

  Execute a SQL statement that returns a single ResultSet.

  Parameters:
    sql - typically this is a static SQL SELECT statement
  Returns:
    a ResultSet that contains the data produced by the query; never null
  Throws: SQLException
    if a database-access error occurs.

executeUpdate

     public abstract int executeUpdate(String sql) throws SQLException

  Execute a SQL INSERT, UPDATE or DELETE statement. In addition, SQL statements that return nothing such as SQL DDL statements can be executed.

  Parameters:
    sql - a SQL INSERT, UPDATE or DELETE statement or a SQL statement that returns nothing
  Returns:
    either the row count for INSERT, UPDATE or DELETE or 0 for SQL statements that return nothing
  Throws: SQLException
    if a database-access error occurs.

close

     public abstract void close() throws SQLException

  In many cases, it is desirable to immediately release a Statements's database and JDBC resources instead of waiting for this to happen when it is automatically closed; the close method provides this immediate release.

  Note: A Statement is automatically closed when it is garbage collected. When a Statement is closed, its current ResultSet, if one exists, is also closed.

  Throws: SQLException
    if a database-access error occurs.

getMaxFieldSize

     public abstract int getMaxFieldSize() throws SQLException

  The maxFieldSize limit (in bytes) is the maximum amount of data returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR columns. If the limit is exceeded, the excess data is silently discarded.

  Returns:
    the current max column size limit; zero means unlimited
  Throws: SQLException
    if a database-access error occurs.

setMaxFieldSize

     public abstract void setMaxFieldSize(int max) throws SQLException

  The maxFieldSize limit (in bytes) is set to limit the size of data that can be returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability use values greater than 256.

  Parameters:
    max - the new max column size limit; zero means unlimited
  Throws: SQLException
    if a database-access error occurs.

getMaxRows

     public abstract int getMaxRows() throws SQLException

  The maxRows limit is the maximum number of rows that a ResultSet can contain. If the limit is exceeded, the excess rows are silently dropped.

  Returns:
    the current max row limit; zero means unlimited
  Throws: SQLException
    if a database-access error occurs.

setMaxRows

     public abstract void setMaxRows(int max) throws SQLException

  The maxRows limit is set to limit the number of rows that any ResultSet can contain. If the limit is exceeded, the excess rows are silently dropped.

  Parameters:
    max - the new max rows limit; zero means unlimited
  Throws: SQLException
    if a database-access error occurs.

setEscapeProcessing

     public abstract void setEscapeProcessing(boolean enable) throws SQLException

  If escape scanning is on (the default), the driver will do escape substitution before sending the SQL to the database. Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for prepared statements will like have no affect.

  Parameters:
    enable - true to enable; false to disable
  Throws: SQLException
    if a database-access error occurs.

getQueryTimeout

     public abstract int getQueryTimeout() throws SQLException

  The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute. If the limit is exceeded, a SQLException is thrown.

  Returns:
    the current query timeout limit in seconds; zero means unlimited
  Throws: SQLException
    if a database-access error occurs.

setQueryTimeout

     public abstract void setQueryTimeout(int seconds) throws SQLException

  The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute. If the limit is exceeded, a SQLException is thrown.

  Parameters:
    seconds - the new query timeout limit in seconds; zero means unlimited
  Throws: SQLException
    if a database-access error occurs.

cancel

     public abstract void cancel() throws SQLException

  Cancel can be used by one thread to cancel a statement that is being executed by another thread.

  Throws: SQLException
    if a database-access error occurs.

getWarnings

     public abstract SQLWarning getWarnings() throws SQLException

  The first warning reported by calls on this Statement is returned. A Statment's execute methods clear its SQLWarning chain. Subsequent Statement warnings will be chained to this SQLWarning.

  The warning chain is automatically cleared each time a statement is (re)executed.

  Note: If you are processing a ResultSet then any warnings associated with ResultSet reads will be chained on the ResultSet object.

  Returns:
    the first SQLWarning or null
  Throws: SQLException
    if a database-access error occurs.

clearWarnings

     public abstract void clearWarnings() throws SQLException

  After this call, getWarnings returns null until a new warning is reported for this Statement.

  Throws: SQLException
    if a database-access error occurs.

setCursorName

     public abstract void setCursorName(String name) throws SQLException

  setCursorname defines the SQL cursor name that will be used by subsequent Statement execute methods. This name can then be used in SQL positioned update/delete statements to identify the current row in the ResultSet generated by this statement. If the database doesn't support positioned update/delete, this method is a noop.

  Note: By definition, positioned update/delete execution must be done by a different Statement than the one which generated the ResultSet being used for positioning. Also, cursor names must be unique within a Connection.

  Parameters:
    name - the new cursor name.
  Throws: SQLException
    if a database-access error occurs.

execute

     public abstract boolean execute(String sql) throws SQLException

  Execute a SQL statement that may return multiple results. Under some (uncommon) situations a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this, unless you're executing a stored procedure that you know may return multiple results, or unless you're dynamically executing an unknown SQL string. The "execute", "getMoreResults", "getResultSet" and "getUpdateCount" methods let you navigate through multiple results. The "execute" method executes a SQL statement and indicates the form of the first result. You can then use getResultSet or getUpdateCount to retrieve the result, and getMoreResults to move to any subsequent result(s).

  Parameters:
    sql - any SQL statement
  Returns:
    true if the next result is a ResultSet; false if it is an update count or there are no more results
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getResultSet, getUpdateCount, getMoreResults

getResultSet

     public abstract ResultSet getResultSet() throws SQLException

  getResultSet returns the current result as a ResultSet. It should only be called once per result.

  Returns:
    the current result as a ResultSet; null if the result is an update count or there are no more results
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    execute

getUpdateCount

     public abstract int getUpdateCount() throws SQLException

  getUpdateCount returns the current result as an update count; if the result is a ResultSet or there are no more results, -1 is returned. It should only be called once per result.

  Returns:
    the current result as an update count; -1 if it is a ResultSet or there are no more results
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    execute

getMoreResults

     public abstract boolean getMoreResults() throws SQLException

  getMoreResults moves to a Statement's next result. It returns true if this result is a ResultSet. getMoreResults also implicitly closes any current ResultSet obtained with getResultSet. There are no more results when (!getMoreResults() && (getUpdateCount() == -1)

  Returns:
    true if the next result is a ResultSet; false if it is an update count or there are no more results
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    execute

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.